//===================
//
// NAME: apostrophe.js    (c) 2019
//
// VERSION 1.1
//
// AUTHOR: Jean-Claude Rigal mailto:jcrigal@free.fr
// 
// DATE : 18/06/2019
//
// USAGE : doubleclick with Joueurs.xls in the same directory OR drag-and-drop AEIfile.xls
//
// COMMENT: Find "" in comments and show player(s) name
//       arg(0) = AEI xls pathname (default Joueurs.xls in the same directory)
//
//===================

var vbCritical = 16; 
var vbExclamation = 48;
var vbInformation = 64
var strTitre = "Script pour l'import AEI de JATennis";

var ret = main();
WScript.Quit(ret);


function  main () {
    
    var errorExcel;

    var ExcelApp = null;
    var ExcelSheet = null;
	var Excel_file = null;
    var fso = WScript.CreateObject("Scripting.FileSystemObject");
    var WSHShell = WScript.CreateObject("WScript.Shell");
    var objArgs = WScript.Arguments ;                        //Script arg
 
	try {
		ExcelApp = new ActiveXObject("Excel.Application");
		ExcelSheet = new ActiveXObject("Excel.Sheet");
		var strAEIfile = (objArgs.Length == 0) ? fso.GetAbsolutePathName("") + "\\Joueurs.xls" : objArgs(0);
		Excel_file = ExcelApp.Workbooks.Open (strAEIfile); 
	}
	catch(e) {
  	}
    if (ExcelApp == null || ExcelSheet == null) {
        WSHShell.Popup( "Dsol, Microsoft Excel doit tre install sur votre machine", 0,strTitre,vbCritical);
        return 2;
    }
    if (Excel_file == null) {
        WSHShell.Popup( "Le fichier d'import AEI (" + strAEIfile + ") n'est pas trouv" , 0,strTitre,vbCritical);
        return 2;
    }
   
    errorExcel = 0;
    try {
        try {
			var excel_sheet = Excel_file.Worksheets("joueurs");
//			var range = excel_sheet.Range("AX2:AX1000");
			var range = excel_sheet.Range("AJ2:AX1000"); // Version 1.1 pour tenir compte des adresses
			var cell = range.find ("");
			var strMes = "";
			if (cell != null) {
				strMes = "\n\nVeuillez remplacer l'apostrophe () du champ ADRESSE ou COMMENTAIRE dans la fiche AEI des joueurs ci-dessous:\n\n* " + excel_sheet.Cells(cell.Row, 2).Value + " " + excel_sheet.Cells(cell.Row, 3).Value;
				var addrDep = cell.Address;
				do {
					cell = range.findNext(cell);
					if (cell.Address == addrDep || cell==null) break;
					strMes += "\n* " + excel_sheet.Cells(cell.Row, 2).Value + " " + excel_sheet.Cells(cell.Row, 3).Value ;
				}while (true);
			}
        }
        catch (e) {
            errorExcel++;
		}
        ExcelSheet.Application.Quit();
        ExcelApp.Workbooks.Close();
    }
    catch (e) {
        errorExcel++;
	}

    if (errorExcel !=0) {
        WSHShell.Popup( "Dsol, " + ExcelApp.Name + 
                        " n'a pas pu effectuer la vrification", 0,strTitre,vbCritical);
        return 4;
    }
    WSHShell.Popup("Test du fichier AEI " + strAEIfile + 
				         ((strMes!="") ? strMes : "\n\nAucun caractre apostrophe () dans l'adresse ou le commentaire. Ce fichier peut tre import correctement"), 0,strTitre,(strMes=="") ?vbInformation:vbExclamation);
    return 0;
}
